PROGRAM_NAME='FSS Atlona Module Tester,Rev 0'
(***********************************************************)
(*  FILE CREATED ON: 10/23/2012  AT: 15:42:36              *)
(***********************************************************)
(**************************************************************)
(**************************************************************)
(*                                                            *)
(* Front Side Solutions, Inc.  (FSS) Software/Project License *)
(*                                                            *)
(* LICENSE GRANT.                                             *)
(* FSS grants to Licensee the exclusive right to use the FSS  *)
(* Software/Project (herein referred to as FSS Project) in    *)
(* the manner described in this License.  The FSS Project is  *)
(* licensed, not sold.  This license does not grant Licensee  *)
(* the right to create derivative works of the FSS Project.   *)
(* The FSS Project is not exclusive to and may consist of one *)
(* or more of the following or similar: FSS developed control *)
(* system software, touch panel software, graphics works,     *)
(* templates, modules, overlays, documentation, drawings,     *)
(* system configuration files and other FSS products          *)
(* generally associated with Control Systems and/or         *)
(* integrated Audio/Video Projects.  A README.TXT or similar  *)
(* file may be attached with this product packaging.  If so,  *)
(* please refer to the README.TXT file for further            *)
(* information regarding the components of the FSS Project.   *)
(* The FSS Project is subject to restrictions on distribution *)
(* described in this License Agreement.  The authorized       *)
(* entity shall not, and shall not permit any other person    *)
(* to, disclose, display, loan, publish, transfer (whether    *)
(* by sale, assignment, exchange, gift, operation of law or   *)
(* otherwise), license, sublicense, copy, or otherwise        *)
(* disseminate the FSS Project in any method as not           *)
(* specifically described in this license agreement.          *)
(* Licensee may not reverse engineer, decompile, or           *)
(* disassemble the FSS Project.  FSS Projects are licensed    *)
(* on a per-application basis; a single FSS Project may       *)
(* contain multiple licenses for FSS Software products.       *)
(*                                                            *)
(* Licensee will receive (for archival and updating purposes) *)
(* copies of the FSS Project, including Master Source code  *)
(* (i.e. non-proprietary module or open source third party  *)
(* module source code) and reference materials and will be    *)
(* entitled to the use of the FSS Project, as provided, in    *)
(* the specific system/application and facility as per the    *)
(* purchase order and/or FSS quotation governing the specific *)
(* FSS Project.  Licensee has the right, at their discretion, *)
(* to transfer or extend their license of the FSS Project,    *)
(* under the same terms as described in this EULA, to the     *)
(* third party client, hereby know as the End User, upon    *)
(* completion and signoff of the FSS Project and final        *)
(* financial remittance to FSS.  Licensee retains the right   *)
(* to update the FSS Project software, using in-house or    *)
(* third party resources, as required to expand the feature   *)
(* set of the FSS Project or extend the service life of the   *)
(* application; an example of this would be updating the      *)
(* FSS Project to support replacement hardware that is not    *)
(* supported by the original software package as defined in   *)
(* the FSS Project.  Licensee is not granted the right to     *)
(* disassemble or reuse any part of the FSS Project package,  *)
(* including, but not limited to, touch panel files, graphic  *)
(* works, included source code or module files, to produce    *)
(* additional software packages for use in other systems or   *)
(* facilities as not specifically defined per the purchase    *)
(* order and/or FSS quotation governing the specific          *)
(* FSS Project, or in a manner that would allow for           *)
(* generating revenue for any entity other than FSS or cause  *)
(* loss of revenue to FSS.                                    *)
(*                                                            *)
(* If original licensee provides copies of any portion of an  *)
(* FSS Project, in any format and at any time, to the end     *)
(* user, even if original licensee maintains a copy for       *)
(* archival purposes, FSS will consider the license for the   *)
(* FSS Project to be transferred to the end user and the end  *)
(* user will be held to the terms of this license agreement;  *)
(* regardless of whether or not they were informed of         *)
(* (as required by this license agreement) the terms of the   *)
(* license agreement by the transferring party.  This         *)
(* includes, but is not limited to, providing a CD copy of    *)
(* source materials to the end user, and/or loading source  *)
(* code into a digital processor or device in a manner that   *)
(* it can be later retrieved.                                 *)
(*                                                            *)
(* In the event of a transfer of license to the end user, FSS *)
(* requests to be notified in written form (postal letter,    *)
(* facsimile transmission, email, etc.) of the transfer of    *)
(* license and any pertinent information regarding the party  *)
(* to whom the license was transferred to (Point of Contact,  *)
(* phone number, email address, etc.).  This is strictly for  *)
(* the purposes of tracking the owner of the license, should  *)
(* any question come up at a later date regarding who holds   *)
(* the rights to the license for a particular FSS Project.    *)
(*                                                            *)
(* THIRD PARTY OR PROPRIETARY WORKS.                          *)
(* Software produced by FSS may include FSS proprietary       *)
(* and/or third party proprietary code blocks, modules or     *)
(* other written works. In this event, the restrictions for   *)
(* usage and distribution as per the individual License       *)
(* agreement for each proprietary code block or module        *)
(* supersedes the terms of the FSS License Agreement. Source  *)
(* code for proprietary software works, whether FSS or third  *)
(* party, shall not be provided.                              *)
(*                                                            *)
(* ENCRYPTION.                                                *)
(* FSS Projects may include encryption schemes designed to    *)
(* enforce the FSS License and to prevent usage of the FSS    *)
(* Project on unlicensed hardware or in manners nor in        *)
(* accordance with this license agreement.                    *)
(*                                                            *)
(* INTELLECTUAL PROPERTY.                                     *)
(* FSS Projects are owned by FSS and are protected by United  *)
(* States copyright laws, patent laws, international treaty   *)
(* provisions, and/or state of California trade secret laws.  *)
(* Licensee may make copies of the FSS Software solely for    *)
(* backup or archival purposes.  Licensee may copy any        *)
(* written materials accompanying the FSS Project and may     *)
(* reproduce, print, or otherwise commit to paper any         *)
(* drawings, screenshots or other documentation associated    *)
(* with the FSS Project; however this License agreement must  *)
(* accompany any distributed materials in its entirety,       *)
(* including in printed form.  Licensee may not reproduce or  *)
(* commit to paper any source code or other similar materials *)
(* intended to be compiled, loaded, or transferred and        *)
(* executed in its digital form by an electronic device       *)
(* without prior written consent of FSS.                      *)
(*                                                            *)
(* TERMINATION.                                               *)
(* FSS RESERVES THE RIGHT, IN ITS SOLE DISCRETION, TO         *)
(* TERMINATE THIS LICENSE FOR ANY REASON WITH OR WITHOUT      *)
(* PROVIDING WRITTEN NOTICE TO LICENSEE.  In the event that   *)
(* FSS terminates this License, the Licensee shall return or  *)
(* destroy all originals and copies of the FSS Software to    *)
(* FSS and certify in writing that all originals and copies   *)
(* have been returned or destroyed.                           *)
(*                                                            *)
(* WARRANTY.                                                  *)
(* FSS warrants all FSS Projects to be accurate to and        *)
(* conform with or at a level exceeding the written scope of  *)
(* work provided by the original Licensee of the FSS Project  *)
(* for the life of the project, providing that the FSS        *)
(* Project is maintained in its original form, and is         *)
(* operating with all equipment, software or devices as per   *)
(* the original scope of work.  FSS will not be liable for    *)
(* any failures of an FSS Project or any FSS works resulting  *)
(* from modifications or changes to hardware and/or software  *)
(* (such as updating a devices firmware, etc.) or any part    *)
(* of a system after FSS has received acceptance (i.e.        *)
(* completion or signoff) on a particular FSS Project.        *)
(* Further more, any modifications to an FSS Project or       *)
(* other FSS Works, conducted in accordance with this license *)
(* agreement by non-FSS resources, (reference same example of *)
(* updating projector as listed above) renders any warranty   *)
(* obligation by FSS null and void, however the FSS license   *)
(* agreement would still govern the original FSS project in   *)
(* its entirety.  FSS will make good or repair any bugs or   *)
(* failures to an FSS Project occurring within 90 calendar    *)
(* days of project acceptance at no additional charge as per  *)
(* this warranty.                                             *)
(* Any bugs or failures to an FSS project that are reported   *)
(* past the 91st day after project acceptance, will be made   *)
(* good at the cost for travel to and from the project site   *)
(* (per the FSS rate schedule in effect at the time of        *)
(* travel), with no additional charge for onsite labor.       *)
(* If during the course of diagnosing a failure or bug        *)
(* believed to be caused by an FSS Project, it is determined  *)
(* that other components, such as hardware or other software  *)
(* are the root cause of fault (example, faulty wiring,       *)
(* loading alternative firmware/software or a failing control *)
(* processor), FSS will bill, at our discretion, for travel   *)
(* time to the site and/or for actual time accrued (with a    *)
(* four hour minimum) onsite or remotely assisting to help    *)
(* resolve the issues.                                        *)
(*                                                            *)
(*                                                            *)
(*                                                            *)
(* This Agreement replaces and supersedes all previous FSS    *)
(* Software License Agreements and is governed by the laws    *)
(* of the State of California, and all disputes will be       *)
(* resolved in the courts in Orange County, California, USA.  *)
(* For any questions concerning this Agreement, or to contact *)
(* FSS for any reason, please write:                          *)
(*    FSS Software License Department,                        *)
(*    8941 Atlanta Ave, Suite 101                             *)
(*    Huntington Beach, CA, 92646                             *)
(*                                                            *)
(*                                                            *)
(**************************************************************)

(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 03/26/2013  AT: 16:51:24        *)
(***********************************************************)
(*  FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 03/12/2013  AT: 22:14:32                *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*  Calling mudule v1.2                                    *)
(*                                                         *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(* ------------------------------------------------------- *)
(* ------------------------------------------------------- *)
(* ------------------------------------------------------- *)
(* NOTES:																					 				 *)
(*																												 *)
(* 	THIS FILE IS FOR TESTING PURPOSES ONLY AND IS NOT 		 *)
(* 	MEANT TO BE PLUG AND PLAY. IT IS INTENDED TO BE A 		 *)
(* 	GUIDE FOR MODULE IMPLEMENTATION USING RS-232 CONTROL.  *)
(*  THE CORE OF THIS PROGRAM CAN BE USED FOR ANY OF THE 	 *)
(*	FOLLOWING  ATLONA HDMI SWITCHERS:			 								 *)
(* 	AT-PRO2HD1616M; AT-PRO2HD88M; AT-PRO3HD44M	 					 *)
(*																												 *)
(* 	THIS BASELINE CODE CAN BE ALTERED TO SUIT THE SPECIFIC *)
(* 	BOUNDS OF THE RESPECTIVE SWITCHER. I.E. MAX_OUT = 4		 *)
(* 	IF USING THE AT-PRO3HD44M. ALL OF THE COMMON CONTROL	 *)
(* 	FUNCTIONS WILL BE APPLICABLE TO ALL SWITCHERS,				 *)
(* 	I.E. POWER ON, POWER OFF, PRESET RECALL/SAVE, RESET.	 *)
(* 																												 *)
(* 	I/O CHANNELS AND LEVELS WILL BE RELEATIVE TO THE HDMI	 *)
(* 	SWITCHERS MAX IN/OUT VALUES.													 *)
(* 	THIS IS IMPORTANT WHEN USING THE SAMPLE PANEL AS THE   *)
(* 	BARGRAPH RANGE AND CONTROL WAS CREATED FOR THE 16X16	 *)
(* 	AND THUS WOULD NEED TO BE MODIFIED FOR THE 8X8 AND 4X4 *)
(* 	SWITCHERS.																						 *)
(* 																												 *)
(* ------------------------------------------------------- *)
(* ------------------------------------------------------- *)
(* ------------------------------------------------------- *)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
(****************************************************************)
(*                                                         			*)
(* NI-3100  		|	IP: 192.168.001.099 | Master Processor				*)
(* NXV-300 			|	IP: 192.168.001.100 |	Master Control Panel		*)
(*                                                         			*)
(* Subnet Mask	| 255.255.255.000                          			*)
(* Default GW		|	192.168.001.001                         			*)
(* DNS Servers	|	xxx.xxx.xxx.xxx                       				*)
(* DNS Servers	|	xxx.xxx.xxx.xxx                       				*)
(*                                                         			*)
(****************************************************************)
// --- Master Processor ---
dvMaster			=			0:01:0					// This Master Processor

// --- RS-232 Devices ---
dvAtlona			=	 5001:01:0					// Atlona AT-PRO2HD1616M	(RS-232	115200,n,8,1)

// --- Relay Device ---

// --- IR Devices ---

// --- I/O Device ---

// --- Axlink Devices ---

// --- Ethernet Devices ---
dvAvPanl			=	10001:01:0					// Main Touch Panel

// --- Virtual Devices ---
vdvAtlona			=	33001:01:0
vdvDummy			=	33002:01:0					// *Place Holder Device
vdvDebug			= 33100:01:0					// Used for debugging general device commands

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT
// --- Misc ---
LF						= 10
CR						= 13
STX						= $02
ETX						= $03
_TCP_					= 1
_UDP_					= 2
_TELNET_			= 23
DELIM					= $FF
DATA_SND			=	1
DATA_RCV			=	2

OK_2_PLL			= 249
DEBUG_MD			= 250
DEBUG_TX			= 251
DEBUG_RX			= 252

MAX_SRC				= 16									// Maximum number of sources available (May be larger or smaller that MAX_INP)
MAX_INP				= 16									// Maximum number of inputs on a switcher
MAX_OUT				= 16									// Maximum number of outputs on a switcher

MAX_NUM_CMD		= 30									// Maximum number of commands for a device command string lookup
MAX_CMD_LEN		= 64									// Maximum number of characters in a "Command String" i.e. Send_Sting or Send_Command
MAX_RSP_LEN		= 100									// Maximum number of characters to expect in a typical data response
MAX_STR_LEN		= 255									// Maximum number of characters that might be held in a "string" array
MAX_CFG_LEN		= 1024								// Maximum number of characters for something (I don't recall where it was used last)
MAX_BUF_LEN		= 2048								// Maximum number of characters that can be received in a Data_Event! AMX limitation

// --- Pointers and Indexes ---
// - Offsets -

// --- Switcher and DSP I/O ---

// --- Device Channels ---
// - Input -

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

// --- Misc ---
INTEGER nI													// Used in For/Next loops
INTEGER nFlash											// Used for flashing buttons

INTEGER nCurrInp										// For tracking what input has been selected for routing
INTEGER nCurrOut[MAX_OUT]						// For tracking what output(s) have been selected for routing
INTEGER nOutVals[MAX_OUT]						// For tracking what input is will be routed to output
INTEGER nCurrOutVal[MAX_OUT]				// For tracking what input is at each output

CHAR sIpAddress[18]									// For storing the IP address of the switcher
CHAR sIpSubnet_[18]									// For storing the IP Subnet mask of the switcher
CHAR sIpGateway[18]									// For storing the IP gateway of the switcher
CHAR sIpCtlPort[8]									// For storing the IP control port i.e. 23 (Telnet)
CHAR sIpDhcpSet[8]									// For storing the IP DHCP setting

// --- Integer Arrays ---
// --- Touch Panel Buttons ---
VOLATILE INTEGER nCnclEnt[]=
{
	9,																// Cancel
	10																// Enter
}
VOLATILE INTEGER nInpBtns[]=
{
	11,																// Input 1
	12,																// Input 2
	13,																// Input 3
	14,																// Input 4
	15,																// Input 5
	16,																// Input 6
	17,																// Input 7
	18,																// Input 8
	19,																// Input 9
	20,																// Input 10
	21,																// Input 11
	22,																// Input 12
	23,																// Input 13
	24,																// Input 14
	25,																// Input 15
	26 																// Input 16
}
VOLATILE INTEGER nPwrBtns[]=
{
	27,																// Power On
	28																// Power Off
}
VOLATILE INTEGER nOutBtns[]=
{
	41,																// Output 1
	42,																// Output 2
	43,																// Output 3
	44,																// Output 4
	45,																// Output 5
	46,																// Output 6
	47,																// Output 7
	48,																// Output 8
	49,																// Output 9
	50,																// Output 10
	51,																// Output 11
	52,																// Output 12
	53,																// Output 13
	54,																// Output 14
	55,																// Output 15
	56 																// Output 16
}
VOLATILE INTEGER nPsetCall[]=
{
	71,																// Recall Preset 1
	72,																// Recall Preset 2
	73,																// Recall Preset 3
	74,																// Recall Preset 4
	75,																// Recall Preset 5
	76,																// Recall Preset 6
	77,																// Recall Preset 7
	78 																// Recall Preset 8
}
VOLATILE INTEGER nPsetSave[]=
{
	81,																// Save Preset 1
	82,																// Save Preset 2
	83,																// Save Preset 3
	84,																// Save Preset 4
	85,																// Save Preset 5
	86,																// Save Preset 6
	87,																// Save Preset 7
	88 																// Save Preset 8
}
VOLATILE INTEGER nOutTrig[]=
{
	101,															// Output 1
	102,															// Output 2
	103,															// Output 3
	104,															// Output 4
	105,															// Output 5
	106,															// Output 6
	107,															// Output 7
	108,															// Output 8
	109,															// Output 9
	110,															// Output 10
	111,															// Output 11
	112,															// Output 12
	113,															// Output 13
	114,															// Output 14
	115,															// Output 15
	116 															// Output 16
}
VOLATILE INTEGER nOutLevs[]=
{
	1,																// Output 1
	2,																// Output 2
	3,																// Output 3
	4,																// Output 4
	5,																// Output 5
	6,																// Output 6
	7,																// Output 7
	8,																// Output 8
	9,																// Output 9
	10,																// Output 10
	11,																// Output 11
	12,																// Output 12
	13,																// Output 13
	14,																// Output 14
	15,																// Output 15
	16 																// Output 16
}
VOLATILE INTEGER nDiagnostics[]=
{
	DEBUG_MD,													//= 250
	DEBUG_TX,													//= 251
	DEBUG_RX													//= 252
}
// --- Device Channels ---

// --- Device Arrays ---

// --- Timeline Arrays ---

// --- Character Arrays ---
CHAR sSwtName[MAX_CMD_LEN] = 'AT-HD4V41'
CHAR sFileName[MAX_CMD_LEN] = ''

(***********************************************************)
(*                INCLUDE DEFINITIONS GO BELOW             *)
(***********************************************************)


(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)
(***********************************************************)
(* FUNCTION  : SendToMasterPort		                         *)
(* PURPOSE   : TO SEND INCOMING OR OUTGOING DATA TO THE 	 *)
(*						 MASTER PORT																 *)
(* PARAMETERS:                                             *)
(* dvDevice  : THE RS-232 DEVICE                           *)
(* cCmdRsp   : THE COMMAND OR THE RESONSE STRING           *)
(* nSndRcv   : THE DIRECTION OF THE DATA                   *)
(* nHex      : SET TO 1 TO SHOW DATA AS HEX                *)
(* sDesc		 : THE DESCRIPTION OF THE DATA                 *)
(***********************************************************)
DEFINE_FUNCTION INTEGER SendToMasterPort ( DEV dvDevice , CHAR cCmdRsp[], INTEGER nSndRcv, INTEGER nHex, CHAR sDesc[] )
{
  LOCAL_VAR INTEGER nByte;
  LOCAL_VAR CHAR cDevice[MAX_CMD_LEN];
  LOCAL_VAR CHAR cString[MAX_BUF_LEN];

  CLEAR_BUFFER cDevice
  CLEAR_BUFFER cString


	IF( nHex )												// If this is a Hex protocol structure...
	{
		FOR( nByte = 1; nByte < LENGTH_STRING( cCmdRsp ); nByte ++ )
		{
			cString = "cString,'$', ITOHEX (cCmdRsp[ nByte ]),','"
		}
		cString = "cString,'$', ITOHEX (cCmdRsp[ nByte ]),' - END',CR,LF"
	}
	ELSE
	{
		cString = "cCmdRsp,' - END',CR,LF"
	}

  SWITCH( nSndRcv )
  {
    CASE DATA_SND: cDevice = 'To '    // Sending to the device
    CASE DATA_RCV: cDevice = 'From '  // Receiving from the device
  }
	IF( LENGTH_STRING( sDesc ) )
	{
		SEND_STRING dvMaster,"cDevice,sDesc,' --> '"
	}
	ELSE
	{
		SEND_STRING dvMaster,"cDevice,ITOA( dvDevice.number ),':',ITOA( dvDevice.port ),':',ITOA( dvDevice.system ),' --> '"
	}

  SEND_STRING dvMaster,"cString"
}
// ----------------------------------------------------------
// --- FEEDBACK ---------------------------------------------
// ----------------------------------------------------------
DEFINE_CALL 'FEEDBACK' ()
{
	LOCAL_VAR INTEGER nIdx;

	// General System
	[dvAvPanl,nPwrBtns[ 1]] = ( [vdvAtlona,27] OR ( [vdvAtlona,29] AND nFlash ) )
	[dvAvPanl,nPwrBtns[ 2]] = ( [vdvAtlona,28] )
	
	// Diagnostics
	[dvAvPanl,DEBUG_MD] = ( [vdvAtlona,DEBUG_MD] )
	[dvAvPanl,DEBUG_TX] = ( [vdvAtlona,DEBUG_TX] )
	[dvAvPanl,DEBUG_RX] = ( [vdvAtlona,DEBUG_RX] )
	
	// Inputs
	[dvAvPanl,nInpBtns[ 1]] = ( nCurrInp ==  1 )
	[dvAvPanl,nInpBtns[ 2]] = ( nCurrInp ==  2 )
	[dvAvPanl,nInpBtns[ 3]] = ( nCurrInp ==  3 )
	[dvAvPanl,nInpBtns[ 4]] = ( nCurrInp ==  4 )
	[dvAvPanl,nInpBtns[ 5]] = ( nCurrInp ==  5 )
	[dvAvPanl,nInpBtns[ 6]] = ( nCurrInp ==  6 )
	[dvAvPanl,nInpBtns[ 7]] = ( nCurrInp ==  7 )
	[dvAvPanl,nInpBtns[ 8]] = ( nCurrInp ==  8 )
	[dvAvPanl,nInpBtns[ 9]] = ( nCurrInp ==  9 )
	[dvAvPanl,nInpBtns[10]] = ( nCurrInp == 10 )
	[dvAvPanl,nInpBtns[11]] = ( nCurrInp == 11 )
	[dvAvPanl,nInpBtns[12]] = ( nCurrInp == 12 )
	[dvAvPanl,nInpBtns[13]] = ( nCurrInp == 13 )
	[dvAvPanl,nInpBtns[14]] = ( nCurrInp == 14 )
	[dvAvPanl,nInpBtns[15]] = ( nCurrInp == 15 )
	[dvAvPanl,nInpBtns[16]] = ( nCurrInp == 16 )
	
	// Outputs
	[dvAvPanl,nOutBtns[ 1]] = ( nCurrOut[ 1] )
	[dvAvPanl,nOutBtns[ 2]] = ( nCurrOut[ 2] )
	[dvAvPanl,nOutBtns[ 3]] = ( nCurrOut[ 3] )
	[dvAvPanl,nOutBtns[ 4]] = ( nCurrOut[ 4] )
	[dvAvPanl,nOutBtns[ 5]] = ( nCurrOut[ 5] )
	[dvAvPanl,nOutBtns[ 6]] = ( nCurrOut[ 6] )
	[dvAvPanl,nOutBtns[ 7]] = ( nCurrOut[ 7] )
	[dvAvPanl,nOutBtns[ 8]] = ( nCurrOut[ 8] )
	[dvAvPanl,nOutBtns[ 9]] = ( nCurrOut[ 9] )
	[dvAvPanl,nOutBtns[10]] = ( nCurrOut[10] )
	[dvAvPanl,nOutBtns[11]] = ( nCurrOut[11] )
	[dvAvPanl,nOutBtns[12]] = ( nCurrOut[12] )
	[dvAvPanl,nOutBtns[13]] = ( nCurrOut[13] )
	[dvAvPanl,nOutBtns[14]] = ( nCurrOut[14] )
	[dvAvPanl,nOutBtns[15]] = ( nCurrOut[15] )
	[dvAvPanl,nOutBtns[16]] = ( nCurrOut[16] )
	
	// Special
	
}                                      
DEFINE_CALL 'DO SWITCH COMMAND' ( INTEGER nSrc, INTEGER nDest[] )
{
	LOCAL_VAR INTEGER nLoop;
	LOCAL_VAR INTEGER nCount;
	LOCAL_VAR INTEGER nFound;
	LOCAL_VAR CHAR sCmdStr[MAX_CFG_LEN];
	
	nCount = 0
	sCmdStr = ""
	
	FOR( nLoop = 1; nLoop <= MAX_OUT; nLoop ++ )
	{
		IF( nDest[ nLoop ] )
		{
			nCount ++
			nFound = nLoop
			
			sCmdStr = "sCmdStr,',',ITOA( nLoop )"
		}
	}
	
	SWITCH( nCount )
	{
		CASE 0:{}												// Didn't find anything
		CASE 1:													// Only found 1 output
		{
			SEND_COMMAND vdvAtlona,"'SWITCH_I_O=',ITOA( nSrc ),',',ITOA( nFound ),DELIM"
		}
		DEFAULT:
		{
			SEND_COMMAND vdvAtlona,"'MULTI_SWT_CMD=',ITOA( nSrc ),sCmdStr,DELIM"
		}
	}
}
(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

//DEFINE_MODULE 'Atlona AT-PRO2HD1616M, Rev 1_2' nMdlComm ( dvAtlona, vdvAtlona, sSwtName )
//DEFINE_MODULE 'Atlona AT-PRO2HD88M, Rev 1_2' nMdlComm ( dvAtlona, vdvAtlona, sSwtName )
//DEFINE_MODULE 'Atlona AT-PRO2HD44M, Rev 1_2' nMdlComm ( dvAtlona, vdvAtlona, sSwtName )
DEFINE_MODULE 'Atlona AT-HD4V41&V42, Rev 1_1' nMdlComm ( dvAtlona, vdvAtlona, sSwtName )

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT
// ----------------------------------------------------------
// --- Data Events ------------------------------------------
// ----------------------------------------------------------
DATA_EVENT[dvMaster]								// This Master Processor
{
	ONLINE:
	{
	}
}
DATA_EVENT[dvAtlona]								// Atlona Switcher
{
	ONLINE:
	{
		SEND_COMMAND DATA.DEVICE, "'SET BAUD 9600,N,8,1 485 DISABLE'"
		SEND_COMMAND DATA.DEVICE, "'HSOFF'"

//		ON [DATA.DEVICE,DEBUG_TX]
//		ON [DATA.DEVICE,DEBUG_RX]
//		ON [DATA.DEVICE,OK_2_PLL]
	}
}
DATA_EVENT[vdvAtlona]								// Atlona AT-PRO2HD1616M	(RS-232	115200,n,8,1)
{
	ONLINE:
	{
		// Setup debugging
//		ON [DATA.DEVICE,DEBUG_TX]
//		ON [DATA.DEVICE,DEBUG_RX]
//		ON [DATA.DEVICE,OK_2_PLL]
	}
	STRING:
	{
		LOCAL_VAR CHAR sResponse[MAX_BUF_LEN];
		LOCAL_VAR CHAR sStrg[MAX_RSP_LEN];
		LOCAL_VAR CHAR sJunk[MAX_RSP_LEN];
		
		sResponse = REMOVE_STRING( DATA.TEXT, "CR,LF", 1 )
		
		SELECT
		{
			ACTIVE( FIND_STRING( sResponse, 'DIAG=', 1 ) ):
			{
				sJunk = REMOVE_STRING( sResponse, 'DIAG=', 1 )
				SEND_COMMAND dvAvPanl,"'^TXT-',ITOA( nDiagnostics[ 1 ] ),',0,',sResponse"
			}
			ACTIVE( FIND_STRING( sResponse, 'TX=', 1 ) ):
			{
				sJunk = REMOVE_STRING( sResponse, 'TX=', 1 )
				SEND_COMMAND dvAvPanl,"'^TXT-',ITOA( nDiagnostics[ 2 ] ),',0,',sResponse"
			}
			ACTIVE( FIND_STRING( sResponse, 'RX=', 1 ) ):
			{
				sJunk = REMOVE_STRING( sResponse, 'RX=', 1 )
				SEND_COMMAND dvAvPanl,"'^TXT-',ITOA( nDiagnostics[ 3 ] ),',0,',sResponse"
			}
			ACTIVE( FIND_STRING( sResponse, 'RS232_CMD=PORT', 1 ) ):
			{
				// THIS IS WHERE YOU WILL PARSE OUT RS-232 COMMANDS
			}
// ----------------------------------------------------------			
			ACTIVE( FIND_STRING( sResponse, 'IPADDR=', 1 ) ):
			{
				sJunk = REMOVE_STRING( sResponse, 'IPADDR=', 1 )
				sIpAddress = REMOVE_STRING( sResponse, "CR,LF", 1 )
			}
			ACTIVE( FIND_STRING( sResponse, 'IPSUBNET=', 1 ) ):
			{
				sJunk = REMOVE_STRING( sResponse, 'IPSUBNET=', 1 )
				sIpSubnet_ = REMOVE_STRING( sResponse, "CR,LF", 1 )
			}
			ACTIVE( FIND_STRING( sResponse, 'IPGATEWAY=', 1 ) ):
			{
				sJunk = REMOVE_STRING( sResponse, 'IPGATEWAY=', 1 )
				sIpGateway = REMOVE_STRING( sResponse, "CR,LF", 1 )
			}
			ACTIVE( FIND_STRING( sResponse, 'IPPORT=', 1 ) ):
			{
				sJunk = REMOVE_STRING( sResponse, 'IPPORT=', 1 )
				sIpCtlPort = REMOVE_STRING( sResponse, "CR,LF", 1 )
			}
			ACTIVE( FIND_STRING( sResponse, 'IPDHCP=', 1 ) ):
			{
				sJunk = REMOVE_STRING( sResponse, 'IPDHCP=', 1 )
				sIpDhcpSet = REMOVE_STRING( sResponse, "CR,LF", 1 )
			}
		}
	}
}
DATA_EVENT[dvAvPanl]								// FOR DEMO PURPOSES ONLY!!
{
	ONLINE:
	{
		LOCAL_VAR INTEGER nIdx;
		
		SELECT
		{
			ACTIVE( FIND_STRING( sSwtName, 'HD4V41', 1 ) ||
							FIND_STRING( sSwtName, 'HD4V42', 1 ) ):
			{
				FOR( nIdx = 1; nIdx <= LENGTH_ARRAY( nInpBtns ); nIdx ++ )
				{
					IF( nIdx <= 4 )
					{
						// Reveal only the I/O and bargraphs that are needed.
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nInpBtns[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutBtns[ nIdx ] ),',0'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutTrig[ nIdx ] ),',0'"
						
						// Set the Bargraph range to support I/O
						SEND_COMMAND dvAvPanl,"'^GLL-',ITOA( nOutTrig[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^GLH-',ITOA( nOutTrig[ nIdx ] ),',4'"
					}
					ELSE
					{
						// Hide all other I/O and bargraphs...
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nInpBtns[ nIdx ] ),',0'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutBtns[ nIdx ] ),',0'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutTrig[ nIdx ] ),',0'"
					}
					// Setup output 1 only
					SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutBtns[ 1 ] ),',1'"
					SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutTrig[ 1 ] ),',1'"
					
					// Set the Bargraph range to support I/O
					SEND_COMMAND dvAvPanl,"'^GLL-',ITOA( nOutTrig[ 1 ] ),',1'"
					SEND_COMMAND dvAvPanl,"'^GLH-',ITOA( nOutTrig[ 1 ] ),',4'"
				}
			}
			ACTIVE( FIND_STRING( sSwtName, '44M', 1 ) ||
							FIND_STRING( sSwtName, 'HD44', 1 ) ):
			{
				FOR( nIdx = 1; nIdx <= LENGTH_ARRAY( nInpBtns ); nIdx ++ )
				{
					IF( nIdx <= 4 )
					{
						// Reveal only the I/O and bargraphs that are needed.
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nInpBtns[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutBtns[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutTrig[ nIdx ] ),',1'"
						
						// Set the Bargraph range to support I/O
						SEND_COMMAND dvAvPanl,"'^GLL-',ITOA( nOutTrig[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^GLH-',ITOA( nOutTrig[ nIdx ] ),',4'"
					}
					ELSE
					{
						// Hide all other I/O and bargraphs...
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nInpBtns[ nIdx ] ),',0'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutBtns[ nIdx ] ),',0'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutTrig[ nIdx ] ),',0'"
					}
				}
			}
			ACTIVE( FIND_STRING( sSwtName, '88M', 1 ) ||
							FIND_STRING( sSwtName, 'HD88', 1 ) ):
			{
				FOR( nIdx = 1; nIdx <= LENGTH_ARRAY( nInpBtns ); nIdx ++ )
				{
					IF( nIdx <= 8 )
					{
						// Reveal only the I/O and bargraphs that are needed.
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nInpBtns[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutBtns[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutTrig[ nIdx ] ),',1'"
						
						// Set the Bargraph range to support I/O
						SEND_COMMAND dvAvPanl,"'^GLL-',ITOA( nOutTrig[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^GLH-',ITOA( nOutTrig[ nIdx ] ),',8'"
					}
					ELSE
					{
						// Hide all other I/O and bargraphs...
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nInpBtns[ nIdx ] ),',0'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutBtns[ nIdx ] ),',0'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutTrig[ nIdx ] ),',0'"
					}
				}
			}
			ACTIVE( FIND_STRING( sSwtName, 'HD1616', 1 ) ):
			{
				FOR( nIdx = 1; nIdx <= LENGTH_ARRAY( nInpBtns ); nIdx ++ )
				{
					IF( nIdx <= 16 )
					{
						// Reveal only the I/O and bargraphs that are needed.
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nInpBtns[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutBtns[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutTrig[ nIdx ] ),',1'"
						
						// Set the Bargraph range to support I/O
						SEND_COMMAND dvAvPanl,"'^GLL-',ITOA( nOutTrig[ nIdx ] ),',1'"
						SEND_COMMAND dvAvPanl,"'^GLH-',ITOA( nOutTrig[ nIdx ] ),',16'"
					}
					ELSE
					{
						// Hide all other I/O and bargraphs...
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nInpBtns[ nIdx ] ),',0'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutBtns[ nIdx ] ),',0'"
						SEND_COMMAND dvAvPanl,"'^SHO-',ITOA( nOutTrig[ nIdx ] ),',0'"
					}
				}
			}
		}
	}
}
// ----------------------------------------------------------
// --- Button Events ----------------------------------------
// ----------------------------------------------------------
BUTTON_EVENT[dvAvPanl,nPwrBtns]			// Power Buttons
{
	PUSH:
	{
		LOCAL_VAR INTEGER nBtn;
		
		nBtn = GET_LAST( nPwrBtns )
		
		SWITCH( nBtn )
		{
			CASE 1:												// Power On
				PULSE [vdvAtlona,27]
			CASE 2:												// Power Off
				PULSE [vdvAtlona,28]
		}
	}
}
BUTTON_EVENT[dvAvPanl,nInpBtns]			// Input selection
{
	PUSH:
	{
		LOCAL_VAR INTEGER nBtn;

		nBtn = GET_LAST( nInpBtns )

		SWITCH( nBtn )
		{
			DEFAULT:
			{
				IF( nCurrInp <> nBtn )
					nCurrInp = nBtn
				ELSE
					nCurrInp = 0
			}
		}
	}
}
BUTTON_EVENT[dvAvPanl,nOutBtns]			// Output selection(s)
{
	PUSH:
	{
		LOCAL_VAR INTEGER nBtn;

		nBtn = GET_LAST( nOutBtns )

		SWITCH( nBtn )
		{
			DEFAULT:
			{
				nCurrOut[ nBtn ] = ! nCurrOut[ nBtn ]
			}
		}
	}
}
BUTTON_EVENT[dvAvPanl,nCnclEnt]			// Cancel/Enter
{
	PUSH:
	{
		LOCAL_VAR INTEGER nBtn;
		LOCAL_VAR INTEGER nOut;
		LOCAL_VAR INTEGER nOk2Route;

		nBtn = GET_LAST( nCnclEnt )

		TO [dvAvPanl,nCnclEnt[ nBtn ]]
		
		SWITCH( nBtn )
		{
			CASE 1:												// Cancel
			{
				OFF [nCurrInp]
				
				FOR( nOut = 1; nOut <= MAX_OUT; nOut ++ )
					OFF [nCurrOut[ nOut ]]
			}
			CASE 2:												// Enter
			{
				IF( nCurrInp )
				{
					OFF [nOk2Route]
					
					FOR( nOut = 1; nOut <= MAX_OUT; nOut ++ )
					{
						IF( nCurrOut[ nOut ] )
							nOk2Route ++
					}
					IF( nOk2Route )
						CALL 'DO SWITCH COMMAND' ( nCurrInp, nCurrOut )
				}
				ELSE
				{
					SEND_COMMAND dvAvPanl,"'ADBEEP'"
				}
			}
		}
	}
	RELEASE:
	{
		LOCAL_VAR INTEGER nOut;
		
		OFF [nCurrInp]
		
		FOR( nOut = 1; nOut <= MAX_OUT; nOut ++ )
		{
			OFF [nCurrOut[ nOut ]]
		}
	}
}
BUTTON_EVENT[dvAvPanl,nOutTrig]			// Bar graph control option (This is the bar graph channel code)
{
	PUSH:
	{
		LOCAL_VAR INTEGER nBtn;

		nBtn = GET_LAST( nOutTrig )

		SWITCH( nBtn )
		{
			DEFAULT:
			{
				ON [vdvAtlona,nOutTrig[ nBtn ]]
			}
		}
	}
	RELEASE:
	{
		LOCAL_VAR INTEGER nBtn;

		nBtn = GET_LAST( nOutTrig )
		
		SEND_LEVEL vdvAtlona, nBtn, nOutVals[ nBtn ]
		
		WAIT 5
			OFF [vdvAtlona,nOutTrig[ nBtn ]]
	}
}
BUTTON_EVENT[dvAvPanl,nDiagnostics]	// Diagnostics
{
	PUSH:
	{
		LOCAL_VAR INTEGER nBtn;

		nBtn = GET_LAST( nDiagnostics )
		
		[vdvAtlona,BUTTON.INPUT.CHANNEL] = ![vdvAtlona,BUTTON.INPUT.CHANNEL]
	}
}
BUTTON_EVENT[dvAvPanl,nPsetCall]		// Recall Preset
{
	PUSH:
	{
		LOCAL_VAR INTEGER nBtn;

		nBtn = GET_LAST( nPsetCall )

		SWITCH( nBtn )
		{
			DEFAULT:
			{
				PULSE [vdvAtlona,nBtn]
				PULSE [dvAvPanl,nPsetCall[nBtn]]
			}
		}
	}
}
BUTTON_EVENT[dvAvPanl,nPsetSave]		// Save Preset
{
	PUSH:
	{
		LOCAL_VAR INTEGER nBtn;

		nBtn = GET_LAST( nPsetSave ) + 10

		SWITCH( nBtn )
		{
			DEFAULT:
			{
				PULSE [vdvAtlona,nBtn]
				PULSE [dvAvPanl,nPsetSave[nBtn]]
			}
		}
	}
}
BUTTON_EVENT[dvAvPanl,1]						// Test command for RS-232 control
{
	PUSH:
	{
		SEND_COMMAND vdvAtlona,"'RS-232_CMD=PORT1,ka 1 ff',CR,DELIM"
	}
}
/*
BUTTON_EVENT[DEV,CHAN]	// Button Event Template
{
	PUSH:
	{
		LOCAL_VAR INTEGER nBtn;

		nBtn = GET_LAST( ? )

		SWITCH( nBtn )
		{
			DEFAULT:{}
		}
	}
}
*/
// ----------------------------------------------------------
// --- Channel Events ---------------------------------------
// ----------------------------------------------------------
/*
CHANNEL_EVENT[DEV,CHAN]	// Channel Event Template
{
	ON:
	{
		CALL 'QUEUE DEBUG ASCII' ( CHANNEL.DEVICE )
	}
	OFF:
	{
		CALL 'QUEUE DEBUG OFF' ( CHANNEL.DEVICE )
	}
}
*/
// ----------------------------------------------------------
// --- Level Events -----------------------------------------
// ----------------------------------------------------------
LEVEL_EVENT[dvAvPanl,nOutLevs]			// Level for sending to switcher
{
	nOutVals[ LEVEL.INPUT.LEVEL ] = LEVEL.VALUE
}
LEVEL_EVENT[vdvAtlona,nOutLevs]			// Level for seeing what input is at this output
{
	IF( ![dvAvPanl,nOutTrig[ LEVEL.INPUT.LEVEL ]] )
	{
		nCurrOutVal[ LEVEL.INPUT.LEVEL ] = LEVEL.VALUE
		SEND_LEVEL dvAvPanl, nOutLevs[ LEVEL.INPUT.LEVEL ], nCurrOutVal[ LEVEL.INPUT.LEVEL ]
	}
}
/*
LEVEL_EVENT[DEV,CHAN]	// Level Event Template
{
}
*/
// ----------------------------------------------------------
// --- Timeline Events --------------------------------------
// ----------------------------------------------------------
/*
TIMELINE_EVENT[TL_???]	// Timeline Event Template
{
}
*/
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM
// Always running routines...
WAIT 8 'FLASH'
	nFlash = !nFlash

CALL 'FEEDBACK' ()

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)